/**
 *
 */
import * as $Util from '@alicloud/tea-util';
import OpenApi, * as $OpenApi from '@alicloud/openapi-client';
import * as $tea from '@alicloud/tea-typescript';
export declare class CreateTagsRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    tagKeyValueParamList?: CreateTagsRequestTagKeyValueParamList[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class CreateTagsResponseBody extends $tea.Model {
    requestId?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class CreateTagsResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: CreateTagsResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DeleteTagRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    key?: string;
    value?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DeleteTagResponseBody extends $tea.Model {
    requestId?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DeleteTagResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: DeleteTagResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DescribeRegionsRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    resourceOwnerId?: number;
    ownerAccount?: string;
    regionId?: string;
    acceptLanguage?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DescribeRegionsResponseBody extends $tea.Model {
    requestId?: string;
    regions?: DescribeRegionsResponseBodyRegions;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DescribeRegionsResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: DescribeRegionsResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagKeysRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    nextToken?: string;
    pageSize?: number;
    category?: string;
    resourceType?: string;
    queryType?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagKeysResponseBody extends $tea.Model {
    nextToken?: string;
    requestId?: string;
    keys?: ListTagKeysResponseBodyKeys;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagKeysResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: ListTagKeysResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagResourcesRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    resourceARN?: string[];
    nextToken?: string;
    pageSize?: number;
    tags?: string;
    category?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagResourcesResponseBody extends $tea.Model {
    nextToken?: string;
    requestId?: string;
    tagResources?: ListTagResourcesResponseBodyTagResources[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagResourcesResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: ListTagResourcesResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagValuesRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    key?: string;
    nextToken?: string;
    pageSize?: number;
    resourceType?: string;
    queryType?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagValuesResponseBody extends $tea.Model {
    nextToken?: string;
    requestId?: string;
    values?: ListTagValuesResponseBodyValues;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagValuesResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: ListTagValuesResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    tags?: string;
    resourceARN?: string[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesResponseBody extends $tea.Model {
    requestId?: string;
    failedResources?: TagResourcesResponseBodyFailedResources;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: TagResourcesResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesRequest extends $tea.Model {
    ownerId?: number;
    resourceOwnerAccount?: string;
    ownerAccount?: string;
    regionId?: string;
    resourceARN?: string[];
    tagKey?: string[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesResponseBody extends $tea.Model {
    requestId?: string;
    failedResources?: UntagResourcesResponseBodyFailedResources;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesResponse extends $tea.Model {
    headers: {
        [key: string]: string;
    };
    body: UntagResourcesResponseBody;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class CreateTagsRequestTagKeyValueParamListTagValueParamList extends $tea.Model {
    value?: string;
    description?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class CreateTagsRequestTagKeyValueParamList extends $tea.Model {
    key?: string;
    tagValueParamList?: CreateTagsRequestTagKeyValueParamListTagValueParamList[];
    description?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DescribeRegionsResponseBodyRegionsRegion extends $tea.Model {
    regionEndpoint?: string;
    localName?: string;
    regionId?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class DescribeRegionsResponseBodyRegions extends $tea.Model {
    region?: DescribeRegionsResponseBodyRegionsRegion[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagKeysResponseBodyKeysKey extends $tea.Model {
    key?: string;
    category?: string;
    description?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagKeysResponseBodyKeys extends $tea.Model {
    key?: ListTagKeysResponseBodyKeysKey[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagResourcesResponseBodyTagResourcesTags extends $tea.Model {
    key?: string;
    value?: string;
    category?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagResourcesResponseBodyTagResources extends $tea.Model {
    resourceARN?: string;
    tags?: ListTagResourcesResponseBodyTagResourcesTags[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class ListTagValuesResponseBodyValues extends $tea.Model {
    value?: string[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesResponseBodyFailedResourcesFailedResourceResult extends $tea.Model {
    code?: string;
    message?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesResponseBodyFailedResourcesFailedResource extends $tea.Model {
    resourceARN?: string;
    result?: TagResourcesResponseBodyFailedResourcesFailedResourceResult;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TagResourcesResponseBodyFailedResources extends $tea.Model {
    failedResource?: TagResourcesResponseBodyFailedResourcesFailedResource[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesResponseBodyFailedResourcesFailedResourceResult extends $tea.Model {
    code?: string;
    message?: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesResponseBodyFailedResourcesFailedResource extends $tea.Model {
    resourceARN?: string;
    result?: UntagResourcesResponseBodyFailedResourcesFailedResourceResult;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class UntagResourcesResponseBodyFailedResources extends $tea.Model {
    failedResource?: UntagResourcesResponseBodyFailedResourcesFailedResource[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export default class Client extends OpenApi {
    constructor(config: $OpenApi.Config);
    getEndpoint(productId: string, regionId: string, endpointRule: string, network: string, suffix: string, endpointMap: {
        [key: string]: string;
    }, endpoint: string): string;
    createTagsWithOptions(request: CreateTagsRequest, runtime: $Util.RuntimeOptions): Promise<CreateTagsResponse>;
    createTags(request: CreateTagsRequest): Promise<CreateTagsResponse>;
    deleteTagWithOptions(request: DeleteTagRequest, runtime: $Util.RuntimeOptions): Promise<DeleteTagResponse>;
    deleteTag(request: DeleteTagRequest): Promise<DeleteTagResponse>;
    describeRegionsWithOptions(request: DescribeRegionsRequest, runtime: $Util.RuntimeOptions): Promise<DescribeRegionsResponse>;
    describeRegions(request: DescribeRegionsRequest): Promise<DescribeRegionsResponse>;
    listTagKeysWithOptions(request: ListTagKeysRequest, runtime: $Util.RuntimeOptions): Promise<ListTagKeysResponse>;
    listTagKeys(request: ListTagKeysRequest): Promise<ListTagKeysResponse>;
    listTagResourcesWithOptions(request: ListTagResourcesRequest, runtime: $Util.RuntimeOptions): Promise<ListTagResourcesResponse>;
    listTagResources(request: ListTagResourcesRequest): Promise<ListTagResourcesResponse>;
    listTagValuesWithOptions(request: ListTagValuesRequest, runtime: $Util.RuntimeOptions): Promise<ListTagValuesResponse>;
    listTagValues(request: ListTagValuesRequest): Promise<ListTagValuesResponse>;
    tagResourcesWithOptions(request: TagResourcesRequest, runtime: $Util.RuntimeOptions): Promise<TagResourcesResponse>;
    tagResources(request: TagResourcesRequest): Promise<TagResourcesResponse>;
    untagResourcesWithOptions(request: UntagResourcesRequest, runtime: $Util.RuntimeOptions): Promise<UntagResourcesResponse>;
    untagResources(request: UntagResourcesRequest): Promise<UntagResourcesResponse>;
}
